NoGrass = {
    name = "NoGrass",
    version = "1.0.2"
	}

local EVENT_MANAGER = GetEventManager()

local originalSettings = {
		distance = GetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_VIEW_DISTANCE),
		particle = GetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_PFX_SUPPRESS_DISTANCE),
		grass = GetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_CLUTTER_2D_QUALITY),
		distortion = GetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_DISTORTION),
		godRays = GetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_GOD_RAYS),
		antiAlias = GetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_ANTIALIASING_TYPE),
		ambient = GetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_AMBIENT_OCCLUSION_TYPE ),
		bloom = GetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_BLOOM),
						}
local combat = false

function NoGrass.onUpdate(_, IsInCombat) 
	if IsInCombat and combat == false then
            NoGrass.inCombat()
        elseif IsInCombat == false and combat == true then
            NoGrass.outCombat()
        end
		
end

function NoGrass.inCombat()
	originalSettings = {
		distance = GetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_VIEW_DISTANCE),
		particle = GetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_PFX_SUPPRESS_DISTANCE),
		grass = GetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_CLUTTER_2D_QUALITY),
		distortion = GetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_DISTORTION),
		godRays = GetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_GOD_RAYS),
		antiAlias = GetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_ANTIALIASING_TYPE),
		ambient = GetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_AMBIENT_OCCLUSION_TYPE ),
		bloom = GetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_BLOOM),
						}

	SetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_VIEW_DISTANCE, 0.4, DONT_SAVE_CURRENT_VALUES)
	SetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_PFX_SUPPRESS_DISTANCE, 35, DONT_SAVE_CURRENT_VALUES)
	SetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_CLUTTER_2D_QUALITY, 0, DONT_SAVE_CURRENT_VALUES)
	SetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_DISTORTION, 0, DONT_SAVE_CURRENT_VALUES)
	SetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_GOD_RAYS, 0, DONT_SAVE_CURRENT_VALUES)
	SetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_BLOOM, 0, DONT_SAVE_CURRENT_VALUES)

	combat = true 
end

function NoGrass.outCombat()
	SetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_VIEW_DISTANCE, originalSettings.distance, DONT_SAVE_CURRENT_VALUES)
	SetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_PFX_SUPPRESS_DISTANCE, originalSettings.particle, DONT_SAVE_CURRENT_VALUES)
	SetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_CLUTTER_2D_QUALITY, originalSettings.grass, DONT_SAVE_CURRENT_VALUES)
	SetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_DISTORTION, originalSettings.distortion, DONT_SAVE_CURRENT_VALUES)
	SetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_GOD_RAYS, originalSettings.godRays, DONT_SAVE_CURRENT_VALUES)
	SetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_ANTIALIASING_TYPE, originalSettings.antiAlias, DONT_SAVE_CURRENT_VALUES)
	SetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_AMBIENT_OCCLUSION_TYPE, originalSettings.ambient, DONT_SAVE_CURRENT_VALUES)
	SetSetting(SETTING_TYPE_GRAPHICS, GRAPHICS_SETTING_BLOOM, originalSettings.bloom, DONT_SAVE_CURRENT_VALUES)
	combat = false
end

function NoGrass.Initialize()
EVENT_MANAGER:RegisterForEvent("RunNoGrass", EVENT_PLAYER_COMBAT_STATE, NoGrass.onUpdate)
EVENT_MANAGER:RegisterForEvent("StopNoGrass", EEVENT_LOGOUT_DEFERRED , NoGrass.outCombat)
end

function NoGrass.OnAddOnLoaded(event, addonName)
	if addonName == NoGrass.name then
		NoGrass.Initialize()
		EVENT_MANAGER:UnregisterForEvent(NoGrass.name, EVENT_ADD_ON_LOADED) 
	end
end

EVENT_MANAGER:RegisterForEvent(NoGrass.name, EVENT_ADD_ON_LOADED, NoGrass.OnAddOnLoaded)